<?php
error_reporting(E_ALL & ~E_WARNING & ~E_NOTICE & ~E_DEPRECATED);
require_once("../../db/connection.php");
$id_room = $_POST['id_room'];
$array = array();
$room=array();

$query = "SELECT r.panorama_image,v.enable_multires FROM svt_rooms as r 
            JOIN svt_virtualtours as v ON v.id=r.id_virtualtour
            WHERE r.id = $id_room LIMIT 1;";
$result = $mysqli->query($query);
if($result) {
    if ($result->num_rows > 0) {
        $row = $result->fetch_array(MYSQLI_ASSOC);
        if($row['enable_multires']) {
            $room_pano = str_replace('.jpg','',$row['panorama_image']);
            $multires_config_file = __DIR__.DIRECTORY_SEPARATOR.'..'.DIRECTORY_SEPARATOR.'..'.DIRECTORY_SEPARATOR.'viewer'.DIRECTORY_SEPARATOR.'panoramas'.DIRECTORY_SEPARATOR.'multires'.DIRECTORY_SEPARATOR.$room_pano.DIRECTORY_SEPARATOR.'config.json';
            if(file_exists($multires_config_file)) {
                $multires_tmp = file_get_contents($multires_config_file);
                $multires_array = json_decode($multires_tmp,true);
                $multires_config = $multires_array['multiRes'];
                $multires_config['basePath'] = '../viewer/panoramas/multires/'.$room_pano;
                $room['multires']=1;
                $room['multires_config']=json_encode($multires_config);
                $room['multires_dir']='../viewer/panoramas/multires/'.$room_pano;
            } else {
                $room['multires']=0;
                $room['multires_config']='';
                $room['multires_dir']='';
            }
        } else {
            $room['multires']=0;
            $room['multires_config']='';
            $room['multires_dir']='';
        }
    }
}

$query = "SELECT 'marker' as what,m.*,r.name as name_room_target,r.id as id_room_target,IFNULL(i.id,0) as id_icon_library, i.image as img_icon_library FROM svt_markers AS m
          JOIN svt_rooms AS r ON m.id_room_target = r.id 
          JOIN svt_virtualtours as v ON v.id = r.id_virtualtour
          LEFT JOIN svt_icons as i ON i.id=m.id_icon_library
          WHERE m.id_room=$id_room;";
$result = $mysqli->query($query);
if($result) {
    if($result->num_rows>0) {
        while($row=$result->fetch_array(MYSQLI_ASSOC)) {
            $array[]=$row;
        }
    }
}
$query = "SELECT 'poi' as what,p.*,IFNULL(i.id,0) as id_icon_library, i.image as img_icon_library FROM svt_pois as p
            LEFT JOIN svt_icons as i ON i.id=p.id_icon_library
            WHERE p.id_room=$id_room;";
$result = $mysqli->query($query);
if($result) {
    if($result->num_rows>0) {
        while($row=$result->fetch_array(MYSQLI_ASSOC)) {
            unset($row['id']);
            if($row['type']=='html_sc') {
                $row['content'] = htmlspecialchars($row['content']);
            }
            if($row['label']==null) $row['label']='';
            $array[]=$row;
        }
    }
}
echo json_encode(array("markers"=>$array,"room"=>$room));