<?php
error_reporting(E_ALL & ~E_WARNING & ~E_NOTICE & ~E_DEPRECATED);
require_once("../../db/connection.php");
require_once("../functions.php");
$id_user = $_POST['id_user'];

switch(get_user_role($id_user)) {
    case 'administrator':
        $where = "";
        break;
    case 'customer':
        $where = " WHERE v.id_user=$id_user ";
        break;
    case 'editor':
        $where = " WHERE v.id IN () ";
        $query = "SELECT GROUP_CONCAT(id_virtualtour) as ids FROM svt_assign_virtualtours WHERE id_user=$id_user;";
        $result = $mysqli->query($query);
        if($result) {
            if($result->num_rows==1) {
                $row=$result->fetch_array(MYSQLI_ASSOC);
                $ids = $row['ids'];
                $where = " WHERE v.id IN ($ids) ";
            }
        }
        break;
}

$array = array();
$query = "SELECT v.id,UPPER(v.name) as name,v.date_created,v.author,u.username,v.start_date,v.end_date,v.active,u.expire_plan_date FROM svt_virtualtours as v 
            LEFT JOIN svt_users as u ON u.id=v.id_user
            $where 
            ORDER BY v.date_created DESC";
$result = $mysqli->query($query);
if($result) {
    if($result->num_rows>0) {
        while($row=$result->fetch_array(MYSQLI_ASSOC)) {
            if($row['active']==0) {
                $row['status']=0;
            } else {
                $row['status']=1;
            }
            $row['date_created'] = date("d M Y",strtotime($row['date_created']));
            if(!empty($row['expire_plan_date'])) {
                if (new DateTime() > new DateTime($row['expire_plan_date'])) {
                    $row['status']=0;
                }
            }
            if((!empty($row['start_date'])) && ($row['start_date']!='0000-00-00')) {
                if (new DateTime() < new DateTime($row['start_date']." 00:00:00")) {
                    $row['status']=0;
                }
                $row['start_date'] = date("d M Y",strtotime($row['start_date']));
            } else {
                $row['start_date'] = "";
            }
            if((!empty($row['end_date'])) && ($row['end_date']!='0000-00-00')) {
                if (new DateTime() > new DateTime($row['end_date']." 23:59:59")) {
                    $row['status']=0;
                }
                $row['end_date'] = date("d M Y",strtotime($row['end_date']));
            } else {
                $row['end_date'] = "";
            }
            if($row['author']!=$row['username']) {
                $row['author'] = $row['username']." (".$row['author'].")";
            }

            $array[]=$row;
        }
    }
}
echo json_encode($array);