<?php
error_reporting(E_ALL & ~E_WARNING & ~E_NOTICE & ~E_DEPRECATED);
ini_set("memory_limit",-1);
ini_set('max_execution_time', 9999);
require_once(__DIR__."/../db/connection.php");

$path = realpath(dirname(__FILE__) . '/..');
if(isset($_GET['check_req'])) {
    $check_req = 1;
} else {
    $check_req = 0;
}
if(isset($argv[1])) {
    $force_update = true;
} else {
    $force_update = false;
}
if(isset($argv[2])) {
    $id_virtualtour = $argv[2];
    $where = "AND id = $id_virtualtour";
} else {
    $where = "";
}

if(!isEnabled('shell_exec')) {
    echo json_encode(array("status"=>"error","msg"=>"php <b>shell_exec</b> function disabled"));
    exit;
}

$command = 'dpkg-query -W -f=\'${Status}\' python3 2>&1';
$output = shell_exec($command);
if (strpos($output, 'command not found') !== false) {
    $command = 'rpm -q python3 2>&1';
    $output = shell_exec($command);
    if (strpos($output, 'not installed') !== false) {
        echo json_encode(array("status"=>"error","msg"=>"Missing package <b>python3</b>.<br>Execute the command \"apt-get install python3\" on your server."));
        exit;
    }
} else {
    if (strpos($output, 'installed') === false) {
        echo json_encode(array("status"=>"error","msg"=>"Missing package <b>python3</b>.<br>Execute the command \"apt-get install python3\" on your server."));
        exit;
    }
}
$command = 'dpkg-query -W -f=\'${Status}\' python3-pil 2>&1';
$output = shell_exec($command);
if (strpos($output, 'command not found') !== false) {
    $command = 'rpm -q python3-pil 2>&1';
    $output = shell_exec($command);
    if (strpos($output, 'not installed') !== false) {
        echo json_encode(array("status"=>"error","msg"=>"Missing package <b>python3-pil</b>.<br>Execute the command \"apt-get install python3-pil\" on your server."));
        exit;
    }
} else {
    if (strpos($output, 'installed') === false) {
        echo json_encode(array("status"=>"error","msg"=>"Missing package <b>python3-pil</b>.<br>Execute the command \"apt-get install python3-pil\" on your server."));
        exit;
    }
}
$command = 'dpkg-query -W -f=\'${Status}\' hugin-tools 2>&1';
$output = shell_exec($command);
if (strpos($output, 'command not found') !== false) {
    $command = 'rpm -q hugin-tools 2>&1';
    $output = shell_exec($command);
    if (strpos($output, 'not installed') !== false) {
        echo json_encode(array("status"=>"error","msg"=>"Missing package <b>hugin-tools</b>.<br>Execute the command \"apt-get install hugin-tools\" on your server."));
        exit;
    }
} else {
    if (strpos($output, 'installed') === false) {
        echo json_encode(array("status"=>"error","msg"=>"Missing package <b>hugin-tools</b>.<br>Execute the command \"apt-get install hugin-tools\" on your server."));
        exit;
    }
}

$command = 'command -v nona 2>&1';
$output = shell_exec($command);
if($output=="") {
    echo json_encode(array("status"=>"error","msg"=>"Missing command nona."));
    exit;
} else {
    $path_nona = trim($output);
}

$command = 'command -v python3 2>&1';
$output = shell_exec($command);
if($output=="") {
    echo json_encode(array("status"=>"error","msg"=>"Missing command python3."));
    exit;
} else {
    $path_python = trim($output);
}

if($check_req)  {
    echo json_encode(array("status"=>"ok","msg"=>"All requirements are met."));
    exit;
}

if (!file_exists(dirname(__FILE__).'/../viewer/panoramas/multires/')) {
    mkdir(dirname(__FILE__).'/../viewer/panoramas/multires/', 0775);
}

$array_rooms = array();
$query_vt = "SELECT id,compress_jpg FROM svt_virtualtours WHERE enable_multires=1 $where;";
$result_vt = $mysqli->query($query_vt);
if($result_vt) {
    if ($result_vt->num_rows>0) {
        while($row_vt = $result_vt->fetch_array(MYSQLI_ASSOC)) {
            $id_vt = $row_vt['id'];
            $quality = $row_vt['compress_jpg'];
            if(empty($quality)) $quality = 100;
            if($force_update) {
                $query = "SELECT id,panorama_image,name FROM svt_rooms WHERE id_virtualtour=$id_vt AND type='image';";
            } else {
                $query = "SELECT id,panorama_image,name FROM svt_rooms WHERE id_virtualtour=$id_vt AND multires_status=0 AND type='image';";
            }
            $result = $mysqli->query($query);
            if($result) {
                if ($result->num_rows>0) {
                    while ($row = $result->fetch_array(MYSQLI_ASSOC)) {
                        $array_rooms[] = $row;
                        $id_room = $row['id'];
                        $mysqli->query("UPDATE svt_rooms SET multires_status=1 WHERE id=$id_room;");
                    }
                }
            }
        }
    }
}

foreach ($array_rooms as $room) {
    $id_room = $room['id'];
    $name = $room['name'];
    $pano = str_replace(".jpg","",$room['panorama_image']);
    if($force_update) {
        $command = "rm -R ".$path.DIRECTORY_SEPARATOR."viewer".DIRECTORY_SEPARATOR."panoramas".DIRECTORY_SEPARATOR."multires".DIRECTORY_SEPARATOR.$pano;
        shell_exec($command);
    }
    if(file_exists($path.DIRECTORY_SEPARATOR."viewer".DIRECTORY_SEPARATOR."panoramas".DIRECTORY_SEPARATOR."original".DIRECTORY_SEPARATOR.$pano.".jpg")) {
        $pano_path = $path.DIRECTORY_SEPARATOR."viewer".DIRECTORY_SEPARATOR."panoramas".DIRECTORY_SEPARATOR."original".DIRECTORY_SEPARATOR.$pano.".jpg";
    } else {
        $pano_path = $path.DIRECTORY_SEPARATOR."viewer".DIRECTORY_SEPARATOR."panoramas".DIRECTORY_SEPARATOR.$pano.".jpg";
    }
    $command = $path_python." ".$path.DIRECTORY_SEPARATOR."services".DIRECTORY_SEPARATOR."generate.py --output ".$path.DIRECTORY_SEPARATOR."viewer".DIRECTORY_SEPARATOR."panoramas".DIRECTORY_SEPARATOR."multires".DIRECTORY_SEPARATOR."$pano --haov 360.0 --vaov 180.0 --nona $path_nona --quality $quality $pano_path 2>&1";
    $output = shell_exec($command);
    if(file_exists($path.DIRECTORY_SEPARATOR."viewer".DIRECTORY_SEPARATOR."panoramas".DIRECTORY_SEPARATOR."multires".DIRECTORY_SEPARATOR.$pano.DIRECTORY_SEPARATOR."config.json")) {
        $mysqli->query("UPDATE svt_rooms SET multires_status=2 WHERE id=$id_room;");
    } else {
        $mysqli->query("UPDATE svt_rooms SET multires_status=0 WHERE id=$id_room;");
    }
}

function isEnabled($func) {
    return is_callable($func) && false === stripos(ini_get('disable_functions'), $func);
}